import java.util.Scanner;
public class Distribuicao {

	public static void main(String[] args) {
	
		Scanner scan = new Scanner(System.in);
		
		//Pega a linha de entrada
		String linha = scan.nextLine();
		
		//Lao que executa o programa enquanto a linha no for "0"
		while(!linha.equals("0")){
			//Converte a entrada para o nmero de tipos
			int tipos = Integer.parseInt(linha);
			//cria um vetor para armazenar as linhas que descrevem cada modelo de carro que a fbrica produz
			String[] modelos = new String[tipos];
			
			//Recebe as descries dos modelos
			for(int i = 0; i < tipos; i++){
				modelos[i] = scan.nextLine();
			}
			
			//Recebe o nmero de lojas como uma string e converte ele para inteiro logo em seguida
			String lojas = scan.nextLine();
			int nLojas = Integer.parseInt(lojas);
			
			//Varivel booleana que indica se cada uma das lojas foi atendida
			boolean foiAtendida = false;
			
			//Lao que recebe as informaes referentes a cada loja e verifica se ela foi atendida ou no
			for(int i = 0; i < nLojas; i++){
				//Assumi-se que a loja no foi atendida, inicialmente.
				foiAtendida = false;
				
				//Recebe a quantidade de pedidos que foram feitos pela loja atual
				String pedidos = scan.nextLine();
				int p = Integer.parseInt(pedidos);
				
				//Recebe a descrio de cada pedido da loja
				for(int j = 0; j < p; j++){
					
					//recebe a linha do pedido
					String l = scan.nextLine();
					String[] carro = l.split(" ");
					
					//Lao que compara o pedido com o que a fbrica produziu, que est armazenado no vetor de modelos
					for(int k = 0; k < tipos; k++){
						
						//D split na linha do respectivo modelo que ser comparado
						String[] carroDaFabrica = modelos[k].split(" ");
						
						//Se o pedido corresponder com o modelo fabricado e com a cor, verifica-se as quantidades
						if(carro[0].equals(carroDaFabrica[0]) && carro[1].equals(carroDaFabrica[1])){
							
							int unDisp = Integer.parseInt(carroDaFabrica[2]);
							int unSol = Integer.parseInt(carro[2]);
							
							//Se a quantidade for suficiente, o pedido  atendido e decrementa-se a quantidade solicitada	
							if(unSol <= unDisp){
								
								String r = carroDaFabrica[0] +  " " + carroDaFabrica[1] + " " + (unDisp - unSol);
								modelos[k] = r;
								foiAtendida = true;
								//Se o pedido foi aceito, no continua a comparao com os outros modelos para esta loja
								break;
							}
						}
					}
				}
				
				if(!foiAtendida) {
					System.out.println("Nao foi possivel atender minimamente aos pedidos");
					break;
				}
			}
			
			if(foiAtendida) System.out.println("Foi possivel atender minimamente aos pedidos");
			scan.nextLine();
			linha = scan.nextLine();
		}
	}
}
